<?php

/**
 * @file
 * Theme related functions for oEmbed Core
 */

function template_preprocess_oembed(&$vars, $hook) {
  $embed = $vars['embed'];
  if ($embed) {

    $vars['title'] = $embed->title;
    $vars['original_url'] = $embed->original_url;

    $vars['title_attributes_array']['class'] = 'oembed-title';
    $vars['content_attributes_array']['class'] = 'oembed-content';

    switch ($embed->type) {

      case 'photo':
        $vars['content'] = array(
          '#theme' => 'image',
          '#path' => $embed->url,
          '#alt' => empty($embed->title) ? t('Embedded image') : $embed->title,
        );
        if (!empty($embed->provider_name)) {
          $vars['content']['#alt'] .= ', '. t('on') .' '. $embed->provider_name;
        }
        $vars['content_attributes_array']['class'] .= ' oembed-photo';
        break;

      case 'link':
        $vars['title_attributes_array']['class'] .= ' oembed-link';

        // oEmbed links render using core link theme unless other preprocess
        // functions suggest other hooks.
        $vars['theme_hook_suggestions'][] = 'link';
        $vars['path'] = $embed->original_url;
        $vars['text'] = $embed->title;
        $vars['options'] = array(
          'absolute' => TRUE,
          'attributes' => $vars['title_attributes_array'],
          'html' => TRUE,
        );
        break;

      default:
        $vars['content'] = $embed->html;
        $vars['content_attributes_array']['class'] .= ' oembed-'. $embed->type;
        break;
    }
  }
}
